#include "windows.h"
#include "classes.h"

#define DIR_DOWN 0
#define DIR_DOWNLEFT 8
#define DIR_LEFT 1
#define DIR_UPLEFT 9
#define DIR_UP 2
#define DIR_UPRIGHT 10
#define DIR_RIGHT 3
#define DIR_DOWNRIGHT 11
int flicker=0;

void PERSON::heartbeat(void)   //Will be done every timer tick
{
//updates stepping/not stepping
if(walking)
 {
  stepcur++;
  if(stepcur>=stepnum){stepping=!stepping; stepcur=0;}
 }
else{stepping=false;stepcur=0;}
}

//draws a PERSON.pict onto hdc with camx and camy in consideration

void PERSON::Draw(HDC hdc,int camx,int camy, bool IT){

//set everything up
 HDC other=CreateCompatibleDC(hdc);
 HDC formask=CreateCompatibleDC(hdc);
 HBITMAP temp=CreateCompatibleBitmap(hdc,width,height);
 SelectObject(formask,temp);
 HBITMAP oldbmp=SelectObject(other,pict);
 int booga;
 if(!stepping)booga=0;
 if(stepping)booga=1;

//Doing transparency stuff
 BitBlt(formask,0,0,width,height,hdc,x-camx,y-camy,SRCCOPY);
 BitBlt(formask,0,0,width,height,other,1+(dir*width)+dir+(width*booga*4+4*booga),2+height,SRCAND);
 BitBlt(formask,0,0,width,height,other,1+(dir*width)+dir+(width*booga*4+4*booga),1,SRCPAINT);

//actual drawing
 BitBlt(hdc,x-camx,y-camy,width,height,formask,0,0,SRCCOPY);
 SetBkMode(hdc,TRANSPARENT);
 RECT rect;rect.left=x-camx-45;rect.top=y-camy-15;rect.right=x-camx+45+32;rect.bottom=y-camy+10;
 DrawText(hdc,name,strlen(name),&rect,DT_CENTER);
 if(IT)
 {
  flicker++;
  rect.top=y-camy-30;
  rect.bottom=y-camy;
  if(flicker>3)SetTextColor(hdc,RGB(175,150,0));
  if(flicker>7)flicker=0;
  DrawText(hdc,"IT!",3,&rect,DT_CENTER);
  SetTextColor(hdc,RGB(0,0,0));
 }

//clean up
 SelectObject(other,oldbmp);
 DeleteDC(other);
 DeleteDC(formask);
 DeleteObject(temp);
}

//much like PERSON::draw but this doesn't take any stepping/direction into consideratoin
void SPRITE::Draw(HDC hdc,int camx,int camy){
//setup
 HDC other=CreateCompatibleDC(hdc);
 HDC formask=CreateCompatibleDC(hdc);
 HBITMAP temp=CreateCompatibleBitmap(hdc,width,height);
 SelectObject(formask,temp);
 HBITMAP oldbmp=SelectObject(other,pict);

//transparency and drawing
 BitBlt(formask,0,0,width,height,hdc,x-camx,y-camy,SRCCOPY);
 BitBlt(formask,0,0,width,height,other,1+width,2+height,SRCAND);
 BitBlt(formask,0,0,width,height,other,1+width,1,SRCPAINT);
 BitBlt(hdc,x-camx,y-camy,width,height,formask,0,0,SRCCOPY);

//cleanup
 SelectObject(other,oldbmp);
 DeleteDC(other);
 DeleteDC(formask);
 DeleteObject(temp);
}

bool *BLOCK::checkhit(PERSON *person)  //This function checks if the *person will be trying to move into the block's area
{
 int s1=person->speed;
 int s2=0;
 int x1=person->x;
 int y1=person->y;
 int x2=person->width;
 int y2=person->height;
 bool test[4]={true,true,true,true};

 //check all directions and return which ones are moveable
 if(type==1)
 {
  if((person->dir==8)||(person->dir==9)||(person->dir==10)||(person->dir==11)){s2=s1;}
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2-1<=y+height)&&(y1-s1+y2>=y)&&(x1+x2-s2>=x)&&(x1+s2<=x+width))test[0]=false;
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2+1>=y)&&(y1+s1+y2<=y+height)&&(x1+x2-s2>=x)&&(x1+s2<=x+width))test[1]=false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x)&&(x1-s1<=x+width))test[2]=false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))        
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x)&&(x1+s1<=x+width))test[3]=false;
  }

//   if((person->dir==DIR_UPLEFT)&&(!test[0]))test[2]=false;
//   if((person->dir==DIR_UPRIGHT)&&(!test[0]))test[3]=false;


 }
 if(type==2)
 {
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2-1<=y+height)&&(y1-s1+y2>=y)&&(x1+x2>=x+((y1+y2)-y)-s1)&&(x1<=x+width+((y1+y2)-y)-s1))test[0]=false;
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2+1>=y)&&(y1+s1+y2<=y+height)&&(x1+x2>=x+((y1+y2)-y)+s1)&&(x1<=x+width+((y1+y2)-y)+s1))test[1]=false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x+((y1+y2)-y)-s1)&&(x1-s1<=x+width+((y1+y2)-y)+s1))test[2]=false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x+((y1+y2)-y)-s1)&&(x1+s1<=x+width+((y1+y2)-y)+s1))test[3]=false;
  }
 }
 if(type==3)
 {
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2-1<=y+height)&&(y1-s1+y2>=y)&&(x1+x2>=x-((y1+y2)-y)+s1)&&(x1<=x+width-((y1+y2)-y)+s1)){test[0]=false;}
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2+1>=y)&&(y1+s1+y2<=y+height)&&(x1+x2>=x-((y1+y2)-y)-s1)&&(x1<=x+width-((y1+y2)-y)-s1))test[1]=false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x-((y1+y2)-y)-s1)&&(x1-s1<=x+width-((y1+y2)-y)+s1))test[2]=false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x-((y1+y2)-y)-s1)&&(x1+s1<=x+width-((y1+y2)-y)+s1))test[3]=false;
  }
 }

return test;
}

bool HOTSPOT::checkhit(PERSON *person)
{
 int s1=person->speed;
 int x1=person->x;
 int y1=person->y;
 int x2=person->width;
 int y2=person->height;
 bool test;

 //check all directions and return which ones are moveable
 if(type==1)
 {
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2<=y+height)&&(y1-s1+y2>=y)&&(x1+x2>=x)&&(x1<=x+width))return false;
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2>=y)&&(y1+s1+y2<=y+height)&&(x1+x2>=x)&&(x1<=x+width))return false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x)&&(x1-s1<=x+width))return false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x)&&(x1+s1<=x+width))return false;
  }
 }
 if(type==2)
 {
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2<=y+height)&&(y1-s1+y2>=y)&&(x1+x2>=x+((y1+y2)-y)-s1)&&(x1<=x+width+((y1+y2)-y)-s1))return false;
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2>=y)&&(y1+s1+y2<=y+height)&&(x1+x2>=x+((y1+y2)-y)+s1)&&(x1<=x+width+((y1+y2)-y)+s1))return false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x+((y1+y2)-y)-s1)&&(x1-s1<=x+width+((y1+y2)-y)+s1))return false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x+((y1+y2)-y)-s1)&&(x1+s1<=x+width+((y1+y2)-y)+s1))return false;
  }
 }
 if(type==3)
 {
  if((person->dir==2)||(person->dir==10)||(person->dir==9))
  {
   if((y1-s1+y2<=y+height)&&(y1-s1+y2>=y)&&(x1+x2>=x-((y1+y2)-y)+s1)&&(x1<=x+width-((y1+y2)-y)+s1)){return false;}
  }
  if((person->dir==0)||(person->dir==8)||(person->dir==11))
  {
   if((y1+s1+y2>=y)&&(y1+s1+y2<=y+height)&&(x1+x2>=x-((y1+y2)-y)-s1)&&(x1<=x+width-((y1+y2)-y)-s1))return false;
  }
  if((person->dir==1)||(person->dir==8)||(person->dir==9))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2-s1>=x-((y1+y2)-y)-s1)&&(x1-s1<=x+width-((y1+y2)-y)+s1))return false;
  }
  if((person->dir==3)||(person->dir==10)||(person->dir==11))
  {
   if((y1+y2>=y)&&(y1+y2<=y+height)&&(x1+x2+s1>=x-((y1+y2)-y)-s1)&&(x1+s1<=x+width-((y1+y2)-y)+s1))return false;
  }
 }

return true;
}

